<!-- #include virtual="/quickstart/winforms/include/header.inc" -->

      <H4>What is Win Forms?</H4>
      <P>Win Forms is a framework for building Windows client applications
      that utilize the NGWS Runtime. Win Forms applications can be written in 
      any language that supports the NGWS Runtime. Some of the advantages of
      using Win Forms include:</P>
      <P><B>Simplicity and power: </B>Win Forms offers a programming model for 
      developing Windows applications that has the simplicity of the Visual 
      Basic 6 programming model and the full power and flexibility of the COM+ 
      2.0 Runtime.</P>
      <P><B>Lower TCO: </B>Win Forms takes advantage of the versioning and 
      deployment features of the NGWS runtime to offer reduced deployment 
      costs and higher application robustness over time. This significantly impacts the
      maintenance costs (Total Cost of Ownership) for applications 
      written in Win Forms.</P>
      <P><B>Architecture for Controls: </B>Win Forms offers an architecture for
      controls and control containers based on concrete implementation of the
      control and container classes. This significantly reduces
      control-container interoperability issues.</P>
      <P><B>Secure: </B>Win Forms takes full advantage of the security features 
      of the NGWS runtime. This means that Win Forms can be used implement 
      everything from an untrusted control running in the browser to a fully 
      trusted application installed on a user's hard drive.</P>
      <P><B>WebServices Support: </B>Win Forms offers full support for quickly 
      and easily connecting to Web Services.</P>
      <P><B>Rich Graphics: </B>Win Forms is one of the first ship vehicles for 
      GDI+, a new version of the Windows Graphical Device Interface (GDI) that 
      supports Alpha blending, texture brushes, advanced transforms, Rich Text 
      support, and more.</P>
      <P><B>Controls: </B>Win Forms offers a rich set of controls that encompass 
      all of the controls offered by Windows and new features such as new 
      &quot;flat look" styles for Buttons, Radio Buttons and Checkboxes.  Refer 
      to <a href="/quickstart/winforms/doc/WinFormsSamples.aspx" 
      style="color:darkred">Control Samples </A>for the complete list of 
      controls.  </P> 
      <P><B>Data Aware: </B>Win Forms offers full support for the ADO+ data 
      model.</P>
      <P><B>ActiveX Support: </B>Win Forms offers full support for ActiveX
      controls. You can easily host ActiveX controls in a Win Forms application.
      You can also host a Win Form control as an ActiveX control. </P>
      <P><B>Licensing: </B>Win Forms takes advantage of the NGWS Runtime 
      enhanced licensing model. </P>
      <P><B>Printing: </B>Win Forms offers a printing framework that enables 
      applications to provide comprehensive reports.</P>
      <P><B>Accessibility: </B>Win Forms controls implement the interfaces 
      defined by Microsoft Active Accessibility (MSAA) making it straightforward 
      to build applications that support accessibility aids such as screen 
      readers.</P>
      <P><B>Design-time: </B>Win Forms takes full advantage of the "Meta-data" 
      and Component Model features offered by the NGWS Runtime to provide
      thorough design-time support both for control users and for control implementers.</P>

<!-- #include virtual="/quickstart/winforms/include/footer.inc" -->
