<!-- #include virtual="/quickstart/winforms/include/header.inc" -->

<H4>A first Win Forms application</H4>
      
<P>Getting started with Win Forms is very straight forward.  The following 
example simply displays a top level window (called a Form) and sets the 
caption bar text to "Hello World".</P> 

<br>
<Code:CodeSnippet runat=server>

<template name="CsTemplate">
    <xmp class=code1>
    
   namespace Microsoft.Samples.WinForms.Cs.SimpleHelloWorld {
       using System;
       using System.WinForms;

       public class SimpleHelloWorld : Form {

           public static int Main(string[] args) {
               Application.Run(new SimpleHelloWorld());
               return 0;
           }

           public SimpleHelloWorld() {
               this.Text = "Hello World";
           }
       }
   }
    </xmp>
</template>

<template name="VBTemplate">
   <xmp class=code1>

   Imports System
   Imports System.ComponentModel
   Imports System.Drawing
   Imports System.WinForms

   Namespace Microsoft.Samples.WinForms.VB.SimpleHelloWorld 

       Public Class SimpleHelloWorld
           Inherits System.WinForms.Form

           'Run the application
           Shared Sub Main()
               System.WinForms.Application.Run(New SimpleHelloWorld())
           End Sub

           Public Sub New() 
               MyBase.New
               Me.Text = "Hello World"
           End Sub
           
       End Class
       
   End Namespace
   </xmp>
</template>

</Code:CodeSnippet>

<p>To view and run this sample:
<br><br>
<Code:CodeSnippet runat=server>
    
    <template name="CsTemplate">
        <Acme:SourceRef 
        RunSample="/quickstart/winforms/Samples/Cs/SimpleHelloWorld" 
        ViewSource="/quickstart/winforms/Samples/Cs/SimpleHelloWorld/SimpleHelloWorld.src"
        Icon = "/quickstart/winforms/images/wflink.jpg"
        Caption="C# Simple Hello World"
        MapRunSamplePath=true
        runat="server" />
    </template>
    
    <template name="VBTemplate">
        <Acme:SourceRef 
        RunSample="/quickstart/winforms/Samples/VB/SimpleHelloWorld" 
        ViewSource="/quickstart/winforms/Samples/VB/SimpleHelloWorld/SimpleHelloWorld.src"
        Icon = "/quickstart/winforms/images/wflink.jpg"
        Caption="VB Simple Hello World"
        MapRunSamplePath=true
        runat="server" />
    </template>
    
</Code:CodeSnippet>


<!-- #include virtual="/quickstart/winforms/include/footer.inc" -->
