<!-- #include virtual="/quickstart/winforms/include/header.inc" -->
      <H4>Using the Win Forms Designer</H4>
      <P>The NGWS SDK includes an application called <B>WinDes</B>. The
      WinDes application provides form designer, Properties window, and Toolbox to perform design time testing of Win Forms controls
        that you have authored. You can
        use these tools to add your control to a form and set its 
      properties in the property browser. In addition to providing a way to view
      and set your control's properties, the Properties window also allows you to
      view custom 
      designers and UI Type Editors you have defined for your control.<P>In addition to providing
        a way to test the controls you have designed, you can also use the
        WinDes Form Designer to create the user interface for a Win Forms application.
      WinDes uses the same underlying code base as the Win Forms designer in 
      Visual Studio.
      <H5>Running WinDes</H5>
      <P>To run WinDes, navigate to the bin directory where you have installed
      the NGWS SDK. Type WinDes.</P>
      <H5>Creating Forms</H5>
      <P>In Windes, you can add a Form by clicking <b>New C#</b> or <b>New VB</b>
      from the File menu. Once the form designer is displayed, you can add controls to the form by double-clicking on a control
      in the Toolbox or by 
      selecting a control in the Toolbox and drawing the control on the form.
      You can set the properties of a control by selecting the control in the
      form designer and setting the 
      properties in the Properties window. To create an event-handling method
      for an event of a control double-click on the 
      control. This will create an even-handling method for the default event of
      the control. You can also create an event-handling method by using the Events tab (Lightning Bolt) on
      the Properties window. 
      <H5>Adding Controls to the Toolbox</H5>
      <P>You can add your controls to the Toolbox for use with the WinDes Form
      Designer.</P>
      <ol>
        <li>Click <b>Add Library</b> from the <b>Edit</b> menu.&nbsp;</li>
        <li>In the dialog box displayed, select the DLL that contains the
          control you want to add to the Toolbox.</li>
      </ol>
      <P>The control will appear at the bottom of the Toolbox. 
      <H5>Code Layout</H5>
      <P>The Form Designer generates code as a result of your actions. This code is placed in a method called 
      <B>InitializeComponent</B>. If you edit this method WinDes may not be able 
      to understand your code and thus may not be able to display the form in
      the form designer. The following example demonstrates what the format for
      the InitializeComponent method that WinDes expects to see code in. </P>
      <P>To view and run this sample: <BR><BR>

<Code:CodeSnippet runat=server>
    
    <template name="CsTemplate">
        <Acme:SourceRef 
        RunSample="/quickstart/winforms/Samples/Cs/DesignableHelloWorld" 
        ViewSource="/quickstart/winforms/Samples/Cs/DesignableHelloWorld/DesignableHelloWorld.src"
        Icon = "/quickstart/winforms/images/wflink.jpg"
        Caption="C# Hello World"
        MapRunSamplePath=true
        runat="server" />
    </template>
    
    <template name="VBTemplate">
        <Acme:SourceRef 
        RunSample="/quickstart/winforms/Samples/VB/DesignableHelloWorld" 
        ViewSource="/quickstart/winforms/Samples/VB/DesignableHelloWorld/DesignableHelloWorld.src"
        Icon = "/quickstart/winforms/images/wflink.jpg"
        Caption="VB Hello World"
        MapRunSamplePath=true
        runat="server" />
    </template>
    
</Code:CodeSnippet>

<!-- #include virtual="/quickstart/winforms/include/footer.inc" -->
