<!-- #include virtual="/QuickStart/winforms/include/header.inc" -->

<h4>Welcome to the Win Forms QuickStart Tutorial</h4>

The Win Forms QuickStart is a series of Win Forms samples and supporting commentary 
designed to quickly acquaint you with the programming model, architecture, and power of the 
Win Forms framework. The QuickStart samples are designed to be short, 
easy-to-understand illustrations of many of the features of Win Forms.
By the time you have completed the QuickStart tutorial you will be able to build fully functioning 
Win Forms applications.
<div class="indent">

<p><span class="caption">What Level of Expertise Is Assumed in the 
QuickStart?</span> <br>The Win Forms QuickStart assumes that you are 
familiar with object oriented programming techniques.  It also assumes 
that you are familiar with concepts such as Windows, Controls, Menus and 
so on.  You should have experience building applications using Microsoft 
Windows(TM) or a similar Graphical User Interface (GUI) programming 
system.  If you have experience building applications using the Windows 
Win32 API, MFC or the Visual Basic forms package then you will quickly get 
to grips with Win Forms.</p> 

<p><span class="caption">Working with the QuickStart Samples</span>
<br>The QuickStart samples are best experienced in the presented sequence. 
Each section assumes that you are familiar with concepts presented in earlier sections.
</p>
<table class=mydd border=0 cellpadding=5>
 <tr>
  <td valign=top><strong>Getting Started</strong></td>
  <td>
        This section explains the Win Forms programming model and the basics of creating a Win Forms
        application - how to use controls, how to respond to events, how to add menus and so on.
  </td>
 </tr>
 <tr>
  <td valign=top><strong>Building Applications</strong></td>
  <td>
        This sections introduces more advanced Win Forms topics such as databinding, how to write controls, printing,
        and so on.
  </td>
 </tr>
 <tr>
  <td valign=top><strong>Control Reference</strong></td>
  <td>
        This section contains samples for each of the controls that ship with Win Forms. Each sample
        illustrates how to use that control.
  </td>
 </tr>

 <tr>
  <td valign=top><strong>How Do I...?</strong></td>
  <td>
        The &quot;How To&quot; section contains more Win Forms samples illustrating error handling, 
        multi-threading issues and so on.
  </td>
 </tr>

 <tr>
  <td valign=top><strong>Related Documentation</strong></td>
  <td>
        This section lists the Win Forms topics in the NGWS SDK documentation.
  </td>
 </tr>
</table>

</p>

</div>

<!-- #include virtual="/QuickStart/winforms/include/footer.inc" -->

