'------------------------------------------------------------------------------
'/ <copyright from='1997' to='2001' company='Microsoft Corporation'>           
'/    Copyright (c) Microsoft Corporation. All Rights Reserved.                
'/       
'/    This source code is intended only as a supplement to Microsoft
'/    Development Tools and/or on-line documentation.  See these other
'/    materials for detailed information regarding Microsoft code samples.
'/
'/ </copyright>                                                                
'/ 
'/  Typed DataSet for Customers generated using XSD tool
'/  TDGUtil.exe in the QuickStart Utils directory used to generate the XSD
'/ 
'------------------------------------------------------------------------------
Imports System
Imports System.Data
Imports System.Core

Namespace Microsoft.Samples.WinForms.VB.Grid.Data 

    Public Class CustomersDataSet
        Inherits DataSet
        
        Private tableCount As Integer
        Private relationCount As Integer
        Private tableCustomers As Customers
        Private tableOrders As Orders
        Private tableOrderDetails As OrderDetails
        Private relationCustomersOrders As DataRelation
        Private relationOrdersOrderDetails As DataRelation
        
        Public Sub New()
            MyBase.New
            Me.InitClass
        End Sub
        
        Public ReadOnly Property Customers As Customers
            Get
                return Me.tableCustomers
            End Get
        End Property
        Public ReadOnly Property Orders As Orders
            Get
                return Me.tableOrders
            End Get
        End Property
        Public ReadOnly Property OrderDetails As OrderDetails
            Get
                return Me.tableOrderDetails
            End Get
        End Property
        
        Private Sub InitClass()
            Me.DataSetName = "CustomersDataSet"
            Me.tableCount = 3
            Me.relationCount = 2
            Me.tableCustomers = New Customers("Customers")
            Me.Tables.Add(Me.tableCustomers)
            Me.tableOrders = New Orders("Orders")
            Me.Tables.Add(Me.tableOrders)
            Me.tableOrderDetails = New OrderDetails("OrderDetails")
            Me.Tables.Add(Me.tableOrderDetails)
            Me.relationCustomersOrders = New DataRelation("CustomersOrders", DataTable.CreateColumnArray(Me.tableCustomers.CustomerIDColumn), DataTable.CreateColumnArray(Me.tableOrders.CustomerIDColumn))
            Me.Relations.Add(Me.relationCustomersOrders)
            Me.relationOrdersOrderDetails = New DataRelation("OrdersOrderDetails", DataTable.CreateColumnArray(Me.tableOrders.OrderIDColumn), DataTable.CreateColumnArray(Me.tableOrderDetails.OrderIDColumn))
            Me.Relations.Add(Me.relationOrdersOrderDetails)
        End Sub
        Protected Overrides Function HasSchemaChanged() As Boolean
            return ((((Me.tableCount) <> (Me.Tables.Count))) Or (((Me.relationCount) <> (Me.Relations.Count))))
        End Function
        Protected Overrides Sub OnRemoveRelation(ByVal relation As DataRelation)
            If ((((relation) Is (Me.relationOrdersOrderDetails))) Or (((relation) Is (Me.relationCustomersOrders)))) Then
                Throw New ArgumentException("Can't remove relation since it it built in to this dataSet")
            End If
        End Sub
        Public Overrides Function ShouldPersistTables() As Boolean
            return ((Me.tableCount) <> (Me.Tables.Count))
        End Function
        Public Overrides Function ShouldPersistRelations() As Boolean
            return ((Me.relationCount) <> (Me.Relations.Count))
        End Function
        Public Overrides Sub ResetTables()
            Dim i As Integer = 0
            Do While ((i) < (Me.Tables.Count))
                If ((((Me.Tables(i)) Is (Me.tableOrderDetails))) Or (((((Me.Tables(i)) Is (Me.tableOrders))) Or (((Me.Tables(i)) Is (Me.tableCustomers)))))) Then
                Else
                    Me.Tables.Remove(Me.Tables(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        Public Overrides Sub ResetRelations()
            Dim i As Integer = 0
            Do While ((i) < (Me.Relations.Count))
                If ((((Me.Relations(i)) Is (Me.relationOrdersOrderDetails))) Or (((Me.Relations(i)) Is (Me.relationCustomersOrders)))) Then
                Else
                    Me.Relations.Remove(Me.Relations(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        Protected Overrides Sub OnRemoveTable(ByVal table As DataTable)
            If ((((table) Is (Me.tableOrderDetails))) Or (((((table) Is (Me.tableOrders))) Or (((table) Is (Me.tableCustomers)))))) Then
                Throw New ArgumentException("Can't remove relation since it it built in to this dataSet")
            End If
        End Sub
        
    End Class
    Public Class Customers
        Inherits DataTable
        Implements System.Collections.ICollection
        
        Private columnCount As Integer
        Private constraintCount As Integer
        Private columnCustomerID As Customers_CustomerID
        Private columnCompanyName As Customers_CompanyName
        Private columnContactName As Customers_ContactName
        Private columnContactTitle As Customers_ContactTitle
        Private columnAddress As Customers_Address
        Private columnCity As Customers_City
        Private columnRegion As Customers_Region
        Private columnPostalCode As Customers_PostalCode
        Private columnCountry As Customers_Country
        Private columnPhone As Customers_Phone
        Private columnFax As Customers_Fax
        Private constraintConstraint1 As Constraint
        Private indexByCustomerID As DataColumn()
        Private CustomersRowChanged As CustomersRowChangeEventHandler
        Private CustomersRowChanging As CustomersRowChangeEventHandler
        Private CustomerIDColumnChanging As DataColumnChangeEventHandler
        Private CompanyNameColumnChanging As DataColumnChangeEventHandler
        Private ContactNameColumnChanging As DataColumnChangeEventHandler
        Private ContactTitleColumnChanging As DataColumnChangeEventHandler
        Private AddressColumnChanging As DataColumnChangeEventHandler
        Private CityColumnChanging As DataColumnChangeEventHandler
        Private RegionColumnChanging As DataColumnChangeEventHandler
        Private PostalCodeColumnChanging As DataColumnChangeEventHandler
        Private CountryColumnChanging As DataColumnChangeEventHandler
        Private PhoneColumnChanging As DataColumnChangeEventHandler
        Private FaxColumnChanging As DataColumnChangeEventHandler
        
        Overloads Public Sub New(ByVal name As [string])
            MyBase.New(name)
            Me.InitClass
        End Sub
        
        Overloads Public Sub New()
            MyBase.New("Customers")
            Me.InitClass
        End Sub
        
        Public ReadOnly Property Count As Integer Implements System.Collections.ICollection.Count
            Get
                return Me.Rows.Count
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_IsReadOnly As Boolean Implements System.Collections.ICollection.IsReadOnly
            Get
                return false
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_IsSynchronized As Boolean Implements System.Collections.ICollection.IsSynchronized
            Get
                return false
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_SyncRoot As [object] Implements System.Collections.ICollection.SyncRoot
            Get
                return Me
            End Get
        End Property
        Public ReadOnly Property CustomerIDColumn As Customers_CustomerID
            Get
                return Me.columnCustomerID
            End Get
        End Property
        Public ReadOnly Property CompanyNameColumn As Customers_CompanyName
            Get
                return Me.columnCompanyName
            End Get
        End Property
        Public ReadOnly Property ContactNameColumn As Customers_ContactName
            Get
                return Me.columnContactName
            End Get
        End Property
        Public ReadOnly Property ContactTitleColumn As Customers_ContactTitle
            Get
                return Me.columnContactTitle
            End Get
        End Property
        Public ReadOnly Property AddressColumn As Customers_Address
            Get
                return Me.columnAddress
            End Get
        End Property
        Public ReadOnly Property CityColumn As Customers_City
            Get
                return Me.columnCity
            End Get
        End Property
        Public ReadOnly Property RegionColumn As Customers_Region
            Get
                return Me.columnRegion
            End Get
        End Property
        Public ReadOnly Property PostalCodeColumn As Customers_PostalCode
            Get
                return Me.columnPostalCode
            End Get
        End Property
        Public ReadOnly Property CountryColumn As Customers_Country
            Get
                return Me.columnCountry
            End Get
        End Property
        Public ReadOnly Property PhoneColumn As Customers_Phone
            Get
                return Me.columnPhone
            End Get
        End Property
        Public ReadOnly Property FaxColumn As Customers_Fax
            Get
                return Me.columnFax
            End Get
        End Property
        Public ReadOnly Property Item(ByVal index As Integer) As CustomersRow
            Get
                return CType(Me.Rows(index),CustomersRow)
            End Get
        End Property
        
        Public Overloads Sub AddCustomersRow(ByVal rowCustomersRow As CustomersRow)
            Me.Rows.Add(rowCustomersRow)
        End Sub
        Public Overloads Function AddCustomersRow(ByVal columnCustomerID As String, ByVal columnCompanyName As String, ByVal columnContactName As String, ByVal columnContactTitle As String, ByVal columnAddress As String, ByVal columnCity As String, ByVal columnRegion As String, ByVal columnPostalCode As String, ByVal columnCountry As String, ByVal columnPhone As String, ByVal columnFax As String) As CustomersRow
            Dim rowCustomersRow As CustomersRow
            rowCustomersRow = CType(Me.NewRow,CustomersRow)
            rowCustomersRow.ItemArray = New [Object]() {columnCustomerID, columnCompanyName, columnContactName, columnContactTitle, columnAddress, columnCity, columnRegion, columnPostalCode, columnCountry, columnPhone, columnFax}
            Me.Rows.Add(rowCustomersRow)
            return rowCustomersRow
        End Function
        Public Sub AddOnCustomersRowChanged(ByVal handler As CustomersRowChangeEventHandler)
            Me.CustomersRowChanged = CType(System.Delegate.Combine(Me.CustomersRowChanged, handler),CustomersRowChangeEventHandler)
        End Sub
        Public Sub AddOnCustomersRowChanging(ByVal handler As CustomersRowChangeEventHandler)
            Me.CustomersRowChanging = CType(System.Delegate.Combine(Me.CustomersRowChanging, handler),CustomersRowChangeEventHandler)
        End Sub
        Public Sub RemoveOnCustomersRowChanged(ByVal handler As CustomersRowChangeEventHandler)
            Me.CustomersRowChanged = CType(System.Delegate.Remove(Me.CustomersRowChanged, handler),CustomersRowChangeEventHandler)
        End Sub
        Public Sub RemoveOnCustomersRowChanging(ByVal handler As CustomersRowChangeEventHandler)
            Me.CustomersRowChanging = CType(System.Delegate.Remove(Me.CustomersRowChanging, handler),CustomersRowChangeEventHandler)
        End Sub
        Public Sub AddOnCustomerIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CustomerIDColumnChanging = CType(System.Delegate.Combine(Me.CustomerIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnCustomerIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CustomerIDColumnChanging = CType(System.Delegate.Remove(Me.CustomerIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnCompanyNameColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CompanyNameColumnChanging = CType(System.Delegate.Combine(Me.CompanyNameColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnCompanyNameColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CompanyNameColumnChanging = CType(System.Delegate.Remove(Me.CompanyNameColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnContactNameColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ContactNameColumnChanging = CType(System.Delegate.Combine(Me.ContactNameColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnContactNameColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ContactNameColumnChanging = CType(System.Delegate.Remove(Me.ContactNameColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnContactTitleColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ContactTitleColumnChanging = CType(System.Delegate.Combine(Me.ContactTitleColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnContactTitleColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ContactTitleColumnChanging = CType(System.Delegate.Remove(Me.ContactTitleColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnAddressColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.AddressColumnChanging = CType(System.Delegate.Combine(Me.AddressColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnAddressColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.AddressColumnChanging = CType(System.Delegate.Remove(Me.AddressColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnCityColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CityColumnChanging = CType(System.Delegate.Combine(Me.CityColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnCityColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CityColumnChanging = CType(System.Delegate.Remove(Me.CityColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnRegionColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.RegionColumnChanging = CType(System.Delegate.Combine(Me.RegionColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnRegionColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.RegionColumnChanging = CType(System.Delegate.Remove(Me.RegionColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnPostalCodeColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.PostalCodeColumnChanging = CType(System.Delegate.Combine(Me.PostalCodeColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnPostalCodeColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.PostalCodeColumnChanging = CType(System.Delegate.Remove(Me.PostalCodeColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnCountryColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CountryColumnChanging = CType(System.Delegate.Combine(Me.CountryColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnCountryColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CountryColumnChanging = CType(System.Delegate.Remove(Me.CountryColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnPhoneColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.PhoneColumnChanging = CType(System.Delegate.Combine(Me.PhoneColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnPhoneColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.PhoneColumnChanging = CType(System.Delegate.Remove(Me.PhoneColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnFaxColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.FaxColumnChanging = CType(System.Delegate.Combine(Me.FaxColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnFaxColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.FaxColumnChanging = CType(System.Delegate.Remove(Me.FaxColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub System_Collections_ICollection_CopyTo(ByVal array As Array, ByVal offset As Integer) Implements System.Collections.ICollection.CopyTo
            Dim i As Integer = 0
            Do While ((i) < (Me.Rows.Count))
                array.SetValue(Me.Rows(i), ((i) + (offset)))
                i = ((i) + (1))
            Loop
        End Sub
        Public Function FindByCustomerID(ByVal columnCustomerID As String) As CustomersRow
            return CType(Me.Rows.Find(New [Object]() {columnCustomerID}),CustomersRow)
        End Function
        Public Function System_Collections_ICollection_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.ICollection.GetEnumerator
            return Me.Rows.All.GetEnumerator
        End Function
        Protected Overrides Function HasSchemaChanged() As Boolean
            return ((Me.columnCount) Is (Me.Columns.Count))
        End Function
        Private Sub InitClass()
            Me.columnCount = 11
            Me.constraintCount = 1
            Me.columnCustomerID = New Customers_CustomerID
            Me.Columns.Add(Me.columnCustomerID)
            Me.columnCompanyName = New Customers_CompanyName
            Me.Columns.Add(Me.columnCompanyName)
            Me.columnContactName = New Customers_ContactName
            Me.Columns.Add(Me.columnContactName)
            Me.columnContactTitle = New Customers_ContactTitle
            Me.Columns.Add(Me.columnContactTitle)
            Me.columnAddress = New Customers_Address
            Me.Columns.Add(Me.columnAddress)
            Me.columnCity = New Customers_City
            Me.Columns.Add(Me.columnCity)
            Me.columnRegion = New Customers_Region
            Me.Columns.Add(Me.columnRegion)
            Me.columnPostalCode = New Customers_PostalCode
            Me.Columns.Add(Me.columnPostalCode)
            Me.columnCountry = New Customers_Country
            Me.Columns.Add(Me.columnCountry)
            Me.columnPhone = New Customers_Phone
            Me.Columns.Add(Me.columnPhone)
            Me.columnFax = New Customers_Fax
            Me.Columns.Add(Me.columnFax)
            Me.PrimaryKey = System.Data.DataTable.CreateColumnArray(Me.columnCustomerID)
            Me.indexByCustomerID = System.Data.DataTable.CreateColumnArray(Me.columnCustomerID)
        End Sub
        Public Function NewCustomersRow() As CustomersRow
            return CType(Me.NewRow,CustomersRow)
        End Function
        Protected Overrides Function NewRowFromBuilder(ByVal builder As DataRowBuilder) As DataRow
            'We need to ensure that all Rows in the tabled are typed rows.
            'Table calls newRow whenever it needs to create a row.
            'So the following conditions are covered by Row newRow(Record record)
            '* Cursor calls table.addRecord(record) 
            '* table.addRow(object[] values) calls newRow(record)    
            return New CustomersRow(builder)
        End Function
        Protected Overrides Sub OnRemoveColumn(ByVal column As DataColumn)
            If ((((((((((((((((((((((column) Is (Me.columnCustomerID))) Or (((column) Is (Me.columnCompanyName))))) Or (((column) Is (Me.columnContactName))))) Or (((column) Is (Me.columnContactTitle))))) Or (((column) Is (Me.columnAddress))))) Or (((column) Is (Me.columnCity))))) Or (((column) Is (Me.columnRegion))))) Or (((column) Is (Me.columnPostalCode))))) Or (((column) Is (Me.columnCountry))))) Or (((column) Is (Me.columnPhone))))) Or (((column) Is (Me.columnFax)))) Then
                Throw New ArgumentException("Can't remove column since it it built in to this dataSet")
            End If
        End Sub
        Protected Overrides Sub OnRowChanged(ByVal e As DataRowChangeEventArgs)
            MyBase.OnRowChanged(e)
            If (Not (Me.CustomersRowChanged) Is (Nothing)) Then
                Me.CustomersRowChanged.Invoke(Me, New CustomersRowChangeEvent(CType(e.Row,CustomersRow), e.Action))
            End If
        End Sub
        Protected Overrides Sub OnRowChanging(ByVal e As DataRowChangeEventArgs)
            If (Not (Me.CustomersRowChanging) Is Nothing) Then
                Me.CustomersRowChanging.Invoke(Me, New CustomersRowChangeEvent(CType(e.Row,CustomersRow), e.Action))
            End If
        End Sub
        Protected Sub OnCustomerIDColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.CustomerIDColumnChanging) Is Nothing) Then
                Me.CustomerIDColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnCompanyNameColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.CompanyNameColumnChanging) Is Nothing) Then
                Me.CompanyNameColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnContactNameColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ContactNameColumnChanging) Is Nothing) Then
                Me.ContactNameColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnContactTitleColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ContactTitleColumnChanging) Is Nothing) Then
                Me.ContactTitleColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnAddressColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.AddressColumnChanging) Is Nothing) Then
                Me.AddressColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnCityColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.CityColumnChanging) Is Nothing) Then
                Me.CityColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnRegionColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.RegionColumnChanging) Is Nothing) Then
                Me.RegionColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnPostalCodeColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.PostalCodeColumnChanging) Is Nothing) Then
                Me.PostalCodeColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnCountryColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.CountryColumnChanging) Is Nothing) Then
                Me.CountryColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnPhoneColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.PhoneColumnChanging) Is Nothing) Then
                Me.PhoneColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnFaxColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.FaxColumnChanging) Is Nothing) Then
                Me.FaxColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Overrides Sub OnColumnChanging(ByVal e As DataColumnChangeEventArgs)
            MyBase.OnColumnChanging(e)
            If ((e.Column) Is (Me.columnCustomerID)) Then
                Me.OnCustomerIDColumnChanging(e)
            Else
                If ((e.Column) Is (Me.columnCompanyName)) Then
                    Me.OnCompanyNameColumnChanging(e)
                Else
                    If ((e.Column) Is (Me.columnContactName)) Then
                        Me.OnContactNameColumnChanging(e)
                    Else
                        If ((e.Column) Is (Me.columnContactTitle)) Then
                            Me.OnContactTitleColumnChanging(e)
                        Else
                            If ((e.Column) Is (Me.columnAddress)) Then
                                Me.OnAddressColumnChanging(e)
                            Else
                                If ((e.Column) Is (Me.columnCity)) Then
                                    Me.OnCityColumnChanging(e)
                                Else
                                    If ((e.Column) Is (Me.columnRegion)) Then
                                        Me.OnRegionColumnChanging(e)
                                    Else
                                        If ((e.Column) Is (Me.columnPostalCode)) Then
                                            Me.OnPostalCodeColumnChanging(e)
                                        Else
                                            If ((e.Column) Is (Me.columnCountry)) Then
                                                Me.OnCountryColumnChanging(e)
                                            Else
                                                If ((e.Column) Is (Me.columnPhone)) Then
                                                    Me.OnPhoneColumnChanging(e)
                                                Else
                                                    If ((e.Column) Is (Me.columnFax)) Then
                                                        Me.OnFaxColumnChanging(e)
                                                    End If
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End Sub
        Public Sub RemoveCustomersRow(ByVal rowCustomersRow As CustomersRow)
            Me.Rows.Remove(rowCustomersRow)
        End Sub
        Public Overrides Function ShouldPersistPrimaryKey() As Boolean
            return false
        End Function
        Public Overrides Sub ResetPrimaryKey()
        End Sub
        Public Overrides Function ShouldPersistColumns() As Boolean
            return ((Me.columnCount) <> (Me.Columns.Count))
        End Function
        Public Overrides Sub ResetColumns()
            Dim i As Integer = 0
            Do While ((i) < (Me.Columns.Count))
                If ((((Me.Columns(i)) Is (Me.columnFax))) Or (((((Me.Columns(i)) Is (Me.columnPhone))) Or (((((Me.Columns(i)) Is (Me.columnCountry))) Or (((((Me.Columns(i)) Is (Me.columnPostalCode))) Or (((((Me.Columns(i)) Is (Me.columnRegion))) Or (((((Me.Columns(i)) Is (Me.columnCity))) Or (((((Me.Columns(i)) Is (Me.columnAddress))) Or (((((Me.Columns(i)) Is (Me.columnContactTitle))) Or (((((Me.Columns(i)) Is (Me.columnContactName))) Or (((((Me.Columns(i)) Is (Me.columnCompanyName))) Or (((Me.Columns(i)) Is (Me.columnCustomerID)))))))))))))))))))))) Then
                Else
                    Me.Columns.Remove(Me.Columns(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        Public Overrides Function ShouldPersistConstraints() As Boolean
            return ((Me.constraintCount) <> (Me.Constraints.Count))
        End Function
        Public Overrides Sub ResetConstraints()
            Dim i As Integer = 0
            Do While ((i) < (Me.Constraints.Count))
                If ((Me.Constraints(i)) Is (Me.constraintConstraint1)) Then
                Else
                    Me.Constraints.Remove(Me.Constraints(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        
    End Class
    Public Class Customers_CustomerID
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("CustomerID", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AllowNull = false
            Me.Unique = true
        End Sub
        
    End Class
    Public Class Customers_CompanyName
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("CompanyName", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AllowNull = false
        End Sub
        
    End Class
    Public Class Customers_ContactName
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ContactName", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_ContactTitle
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ContactTitle", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_Address
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Address", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_City
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("City", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_Region
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Region", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_PostalCode
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("PostalCode", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_Country
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Country", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_Phone
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Phone", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Customers_Fax
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Fax", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders
        Inherits DataTable
        Implements System.Collections.ICollection
        
        Private columnCount As Integer
        Private constraintCount As Integer
        Private columnOrderID As Orders_OrderID
        Private columnCustomerID As Orders_CustomerID
        Private columnEmployeeID As Orders_EmployeeID
        Private columnOrderDate As Orders_OrderDate
        Private columnRequiredDate As Orders_RequiredDate
        Private columnShippedDate As Orders_ShippedDate
        Private columnShipVia As Orders_ShipVia
        Private columnFreight As Orders_Freight
        Private columnShipName As Orders_ShipName
        Private columnShipAddress As Orders_ShipAddress
        Private columnShipCity As Orders_ShipCity
        Private columnShipRegion As Orders_ShipRegion
        Private columnShipPostalCode As Orders_ShipPostalCode
        Private columnShipCountry As Orders_ShipCountry
        Private constraintConstraint1 As Constraint
        Private indexByOrderID As DataColumn()
        Private constraintCustomersOrders As Constraint
        Private OrdersRowChanged As OrdersRowChangeEventHandler
        Private OrdersRowChanging As OrdersRowChangeEventHandler
        Private OrderIDColumnChanging As DataColumnChangeEventHandler
        Private CustomerIDColumnChanging As DataColumnChangeEventHandler
        Private EmployeeIDColumnChanging As DataColumnChangeEventHandler
        Private OrderDateColumnChanging As DataColumnChangeEventHandler
        Private RequiredDateColumnChanging As DataColumnChangeEventHandler
        Private ShippedDateColumnChanging As DataColumnChangeEventHandler
        Private ShipViaColumnChanging As DataColumnChangeEventHandler
        Private FreightColumnChanging As DataColumnChangeEventHandler
        Private ShipNameColumnChanging As DataColumnChangeEventHandler
        Private ShipAddressColumnChanging As DataColumnChangeEventHandler
        Private ShipCityColumnChanging As DataColumnChangeEventHandler
        Private ShipRegionColumnChanging As DataColumnChangeEventHandler
        Private ShipPostalCodeColumnChanging As DataColumnChangeEventHandler
        Private ShipCountryColumnChanging As DataColumnChangeEventHandler
        
        Overloads Public Sub New(ByVal name As [string])
            MyBase.New(name)
            Me.InitClass
        End Sub
        
        Overloads Public Sub New()
            MyBase.New("Orders")
            Me.InitClass
        End Sub
        
        Public ReadOnly Property Count As Integer Implements System.Collections.ICollection.Count
            Get
                return Me.Rows.Count
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_IsReadOnly As Boolean Implements System.Collections.ICollection.IsReadOnly
            Get
                return false
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_IsSynchronized As Boolean Implements System.Collections.ICollection.IsSynchronized
            Get
                return false
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_SyncRoot As [object] Implements System.Collections.ICollection.SyncRoot
            Get
                return Me
            End Get
        End Property
        Public ReadOnly Property OrderIDColumn As Orders_OrderID
            Get
                return Me.columnOrderID
            End Get
        End Property
        Public ReadOnly Property CustomerIDColumn As Orders_CustomerID
            Get
                return Me.columnCustomerID
            End Get
        End Property
        Public ReadOnly Property EmployeeIDColumn As Orders_EmployeeID
            Get
                return Me.columnEmployeeID
            End Get
        End Property
        Public ReadOnly Property OrderDateColumn As Orders_OrderDate
            Get
                return Me.columnOrderDate
            End Get
        End Property
        Public ReadOnly Property RequiredDateColumn As Orders_RequiredDate
            Get
                return Me.columnRequiredDate
            End Get
        End Property
        Public ReadOnly Property ShippedDateColumn As Orders_ShippedDate
            Get
                return Me.columnShippedDate
            End Get
        End Property
        Public ReadOnly Property ShipViaColumn As Orders_ShipVia
            Get
                return Me.columnShipVia
            End Get
        End Property
        Public ReadOnly Property FreightColumn As Orders_Freight
            Get
                return Me.columnFreight
            End Get
        End Property
        Public ReadOnly Property ShipNameColumn As Orders_ShipName
            Get
                return Me.columnShipName
            End Get
        End Property
        Public ReadOnly Property ShipAddressColumn As Orders_ShipAddress
            Get
                return Me.columnShipAddress
            End Get
        End Property
        Public ReadOnly Property ShipCityColumn As Orders_ShipCity
            Get
                return Me.columnShipCity
            End Get
        End Property
        Public ReadOnly Property ShipRegionColumn As Orders_ShipRegion
            Get
                return Me.columnShipRegion
            End Get
        End Property
        Public ReadOnly Property ShipPostalCodeColumn As Orders_ShipPostalCode
            Get
                return Me.columnShipPostalCode
            End Get
        End Property
        Public ReadOnly Property ShipCountryColumn As Orders_ShipCountry
            Get
                return Me.columnShipCountry
            End Get
        End Property
        Public ReadOnly Property Item(ByVal index As Integer) As OrdersRow
            Get
                return CType(Me.Rows(index),OrdersRow)
            End Get
        End Property
        
        Public Overloads Sub AddOrdersRow(ByVal rowOrdersRow As OrdersRow)
            Me.Rows.Add(rowOrdersRow)
        End Sub
        Public Overloads Function AddOrdersRow(ByVal parentCustomersRowByCustomersOrders As CustomersRow, ByVal columnEmployeeID As Integer, ByVal columnOrderDate As DateTime, ByVal columnRequiredDate As DateTime, ByVal columnShippedDate As DateTime, ByVal columnShipVia As Integer, ByVal columnFreight As System.Currency, ByVal columnShipName As String, ByVal columnShipAddress As String, ByVal columnShipCity As String, ByVal columnShipRegion As String, ByVal columnShipPostalCode As String, ByVal columnShipCountry As String) As OrdersRow
            Dim rowOrdersRow As OrdersRow
            rowOrdersRow = CType(Me.NewRow,OrdersRow)
            rowOrdersRow.ItemArray = New [Object]() {Nothing, parentCustomersRowByCustomersOrders.CustomerID, columnEmployeeID, columnOrderDate, columnRequiredDate, columnShippedDate, columnShipVia, columnFreight, columnShipName, columnShipAddress, columnShipCity, columnShipRegion, columnShipPostalCode, columnShipCountry}
            Me.Rows.Add(rowOrdersRow)
            return rowOrdersRow
        End Function
        Public Sub AddOnOrdersRowChanged(ByVal handler As OrdersRowChangeEventHandler)
            Me.OrdersRowChanged = CType(System.Delegate.Combine(Me.OrdersRowChanged, handler),OrdersRowChangeEventHandler)
        End Sub
        Public Sub AddOnOrdersRowChanging(ByVal handler As OrdersRowChangeEventHandler)
            Me.OrdersRowChanging = CType(System.Delegate.Combine(Me.OrdersRowChanging, handler),OrdersRowChangeEventHandler)
        End Sub
        Public Sub RemoveOnOrdersRowChanged(ByVal handler As OrdersRowChangeEventHandler)
            Me.OrdersRowChanged = CType(System.Delegate.Remove(Me.OrdersRowChanged, handler),OrdersRowChangeEventHandler)
        End Sub
        Public Sub RemoveOnOrdersRowChanging(ByVal handler As OrdersRowChangeEventHandler)
            Me.OrdersRowChanging = CType(System.Delegate.Remove(Me.OrdersRowChanging, handler),OrdersRowChangeEventHandler)
        End Sub
        Public Sub AddOnOrderIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.OrderIDColumnChanging = CType(System.Delegate.Combine(Me.OrderIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnOrderIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.OrderIDColumnChanging = CType(System.Delegate.Remove(Me.OrderIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnCustomerIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CustomerIDColumnChanging = CType(System.Delegate.Combine(Me.CustomerIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnCustomerIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.CustomerIDColumnChanging = CType(System.Delegate.Remove(Me.CustomerIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnEmployeeIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.EmployeeIDColumnChanging = CType(System.Delegate.Combine(Me.EmployeeIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnEmployeeIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.EmployeeIDColumnChanging = CType(System.Delegate.Remove(Me.EmployeeIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnOrderDateColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.OrderDateColumnChanging = CType(System.Delegate.Combine(Me.OrderDateColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnOrderDateColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.OrderDateColumnChanging = CType(System.Delegate.Remove(Me.OrderDateColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnRequiredDateColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.RequiredDateColumnChanging = CType(System.Delegate.Combine(Me.RequiredDateColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnRequiredDateColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.RequiredDateColumnChanging = CType(System.Delegate.Remove(Me.RequiredDateColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShippedDateColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShippedDateColumnChanging = CType(System.Delegate.Combine(Me.ShippedDateColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShippedDateColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShippedDateColumnChanging = CType(System.Delegate.Remove(Me.ShippedDateColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShipViaColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipViaColumnChanging = CType(System.Delegate.Combine(Me.ShipViaColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShipViaColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipViaColumnChanging = CType(System.Delegate.Remove(Me.ShipViaColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnFreightColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.FreightColumnChanging = CType(System.Delegate.Combine(Me.FreightColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnFreightColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.FreightColumnChanging = CType(System.Delegate.Remove(Me.FreightColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShipNameColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipNameColumnChanging = CType(System.Delegate.Combine(Me.ShipNameColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShipNameColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipNameColumnChanging = CType(System.Delegate.Remove(Me.ShipNameColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShipAddressColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipAddressColumnChanging = CType(System.Delegate.Combine(Me.ShipAddressColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShipAddressColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipAddressColumnChanging = CType(System.Delegate.Remove(Me.ShipAddressColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShipCityColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipCityColumnChanging = CType(System.Delegate.Combine(Me.ShipCityColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShipCityColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipCityColumnChanging = CType(System.Delegate.Remove(Me.ShipCityColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShipRegionColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipRegionColumnChanging = CType(System.Delegate.Combine(Me.ShipRegionColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShipRegionColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipRegionColumnChanging = CType(System.Delegate.Remove(Me.ShipRegionColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShipPostalCodeColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipPostalCodeColumnChanging = CType(System.Delegate.Combine(Me.ShipPostalCodeColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShipPostalCodeColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipPostalCodeColumnChanging = CType(System.Delegate.Remove(Me.ShipPostalCodeColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnShipCountryColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipCountryColumnChanging = CType(System.Delegate.Combine(Me.ShipCountryColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnShipCountryColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ShipCountryColumnChanging = CType(System.Delegate.Remove(Me.ShipCountryColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub System_Collections_ICollection_CopyTo(ByVal array As Array, ByVal offset As Integer) Implements System.Collections.ICollection.CopyTo
            Dim i As Integer = 0
            Do While ((i) < (Me.Rows.Count))
                array.SetValue(Me.Rows(i), ((i) + (offset)))
                i = ((i) + (1))
            Loop
        End Sub
        Public Function FindByOrderID(ByVal columnOrderID As Integer) As OrdersRow
            return CType(Me.Rows.Find(New [Object]() {columnOrderID}),OrdersRow)
        End Function
        Public Function System_Collections_ICollection_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.ICollection.GetEnumerator
            return Me.Rows.All.GetEnumerator
        End Function
        Protected Overrides Function HasSchemaChanged() As Boolean
            return ((Me.columnCount) Is (Me.Columns.Count))
        End Function
        Private Sub InitClass()
            Me.columnCount = 14
            Me.constraintCount = 2
            Me.columnOrderID = New Orders_OrderID
            Me.Columns.Add(Me.columnOrderID)
            Me.columnCustomerID = New Orders_CustomerID
            Me.Columns.Add(Me.columnCustomerID)
            Me.columnEmployeeID = New Orders_EmployeeID
            Me.Columns.Add(Me.columnEmployeeID)
            Me.columnOrderDate = New Orders_OrderDate
            Me.Columns.Add(Me.columnOrderDate)
            Me.columnRequiredDate = New Orders_RequiredDate
            Me.Columns.Add(Me.columnRequiredDate)
            Me.columnShippedDate = New Orders_ShippedDate
            Me.Columns.Add(Me.columnShippedDate)
            Me.columnShipVia = New Orders_ShipVia
            Me.Columns.Add(Me.columnShipVia)
            Me.columnFreight = New Orders_Freight
            Me.Columns.Add(Me.columnFreight)
            Me.columnShipName = New Orders_ShipName
            Me.Columns.Add(Me.columnShipName)
            Me.columnShipAddress = New Orders_ShipAddress
            Me.Columns.Add(Me.columnShipAddress)
            Me.columnShipCity = New Orders_ShipCity
            Me.Columns.Add(Me.columnShipCity)
            Me.columnShipRegion = New Orders_ShipRegion
            Me.Columns.Add(Me.columnShipRegion)
            Me.columnShipPostalCode = New Orders_ShipPostalCode
            Me.Columns.Add(Me.columnShipPostalCode)
            Me.columnShipCountry = New Orders_ShipCountry
            Me.Columns.Add(Me.columnShipCountry)
            Me.PrimaryKey = System.Data.DataTable.CreateColumnArray(Me.columnOrderID)
            Me.indexByOrderID = System.Data.DataTable.CreateColumnArray(Me.columnOrderID)
        End Sub
        Public Function NewOrdersRow() As OrdersRow
            return CType(Me.NewRow,OrdersRow)
        End Function
        Protected Overrides Function NewRowFromBuilder(ByVal builder As DataRowBuilder) As DataRow
            'We need to ensure that all Rows in the tabled are typed rows.
            'Table calls newRow whenever it needs to create a row.
            'So the following conditions are covered by Row newRow(Record record)
            '* Cursor calls table.addRecord(record) 
            '* table.addRow(object[] values) calls newRow(record)    
            return New OrdersRow(builder)
        End Function
        Protected Overrides Sub OnRemoveColumn(ByVal column As DataColumn)
            If ((((((((((((((((((((((((((((column) Is (Me.columnOrderID))) Or (((column) Is (Me.columnCustomerID))))) Or (((column) Is (Me.columnEmployeeID))))) Or (((column) Is (Me.columnOrderDate))))) Or (((column) Is (Me.columnRequiredDate))))) Or (((column) Is (Me.columnShippedDate))))) Or (((column) Is (Me.columnShipVia))))) Or (((column) Is (Me.columnFreight))))) Or (((column) Is (Me.columnShipName))))) Or (((column) Is (Me.columnShipAddress))))) Or (((column) Is (Me.columnShipCity))))) Or (((column) Is (Me.columnShipRegion))))) Or (((column) Is (Me.columnShipPostalCode))))) Or (((column) Is (Me.columnShipCountry)))) Then
                Throw New ArgumentException("Can't remove column since it it built in to this dataSet")
            End If
        End Sub
        Protected Overrides Sub OnRowChanged(ByVal e As DataRowChangeEventArgs)
            MyBase.OnRowChanged(e)
            If (Not (Me.OrdersRowChanged) Is (Nothing)) Then
                Me.OrdersRowChanged.Invoke(Me, New OrdersRowChangeEvent(CType(e.Row,OrdersRow), e.Action))
            End If
        End Sub
        Protected Overrides Sub OnRowChanging(ByVal e As DataRowChangeEventArgs)
            If (Not (Me.OrdersRowChanging) Is Nothing) Then
                Me.OrdersRowChanging.Invoke(Me, New OrdersRowChangeEvent(CType(e.Row,OrdersRow), e.Action))
            End If
        End Sub
        Protected Sub OnOrderIDColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.OrderIDColumnChanging) Is Nothing) Then
                Me.OrderIDColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnCustomerIDColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.CustomerIDColumnChanging) Is Nothing) Then
                Me.CustomerIDColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnEmployeeIDColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.EmployeeIDColumnChanging) Is Nothing) Then
                Me.EmployeeIDColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnOrderDateColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.OrderDateColumnChanging) Is Nothing) Then
                Me.OrderDateColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnRequiredDateColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.RequiredDateColumnChanging) Is Nothing) Then
                Me.RequiredDateColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShippedDateColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShippedDateColumnChanging) Is Nothing) Then
                Me.ShippedDateColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShipViaColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShipViaColumnChanging) Is Nothing) Then
                Me.ShipViaColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnFreightColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.FreightColumnChanging) Is Nothing) Then
                Me.FreightColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShipNameColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShipNameColumnChanging) Is Nothing) Then
                Me.ShipNameColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShipAddressColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShipAddressColumnChanging) Is Nothing) Then
                Me.ShipAddressColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShipCityColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShipCityColumnChanging) Is Nothing) Then
                Me.ShipCityColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShipRegionColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShipRegionColumnChanging) Is Nothing) Then
                Me.ShipRegionColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShipPostalCodeColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShipPostalCodeColumnChanging) Is Nothing) Then
                Me.ShipPostalCodeColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnShipCountryColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ShipCountryColumnChanging) Is Nothing) Then
                Me.ShipCountryColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Overrides Sub OnColumnChanging(ByVal e As DataColumnChangeEventArgs)
            MyBase.OnColumnChanging(e)
            If ((e.Column) Is (Me.columnOrderID)) Then
                Me.OnOrderIDColumnChanging(e)
            Else
                If ((e.Column) Is (Me.columnCustomerID)) Then
                    Me.OnCustomerIDColumnChanging(e)
                Else
                    If ((e.Column) Is (Me.columnEmployeeID)) Then
                        Me.OnEmployeeIDColumnChanging(e)
                    Else
                        If ((e.Column) Is (Me.columnOrderDate)) Then
                            Me.OnOrderDateColumnChanging(e)
                        Else
                            If ((e.Column) Is (Me.columnRequiredDate)) Then
                                Me.OnRequiredDateColumnChanging(e)
                            Else
                                If ((e.Column) Is (Me.columnShippedDate)) Then
                                    Me.OnShippedDateColumnChanging(e)
                                Else
                                    If ((e.Column) Is (Me.columnShipVia)) Then
                                        Me.OnShipViaColumnChanging(e)
                                    Else
                                        If ((e.Column) Is (Me.columnFreight)) Then
                                            Me.OnFreightColumnChanging(e)
                                        Else
                                            If ((e.Column) Is (Me.columnShipName)) Then
                                                Me.OnShipNameColumnChanging(e)
                                            Else
                                                If ((e.Column) Is (Me.columnShipAddress)) Then
                                                    Me.OnShipAddressColumnChanging(e)
                                                Else
                                                    If ((e.Column) Is (Me.columnShipCity)) Then
                                                        Me.OnShipCityColumnChanging(e)
                                                    Else
                                                        If ((e.Column) Is (Me.columnShipRegion)) Then
                                                            Me.OnShipRegionColumnChanging(e)
                                                        Else
                                                            If ((e.Column) Is (Me.columnShipPostalCode)) Then
                                                                Me.OnShipPostalCodeColumnChanging(e)
                                                            Else
                                                                If ((e.Column) Is (Me.columnShipCountry)) Then
                                                                    Me.OnShipCountryColumnChanging(e)
                                                                End If
                                                            End If
                                                        End If
                                                    End If
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End Sub
        Public Sub RemoveOrdersRow(ByVal rowOrdersRow As OrdersRow)
            Me.Rows.Remove(rowOrdersRow)
        End Sub
        Public Overrides Function ShouldPersistPrimaryKey() As Boolean
            return false
        End Function
        Public Overrides Sub ResetPrimaryKey()
        End Sub
        Public Overrides Function ShouldPersistColumns() As Boolean
            return ((Me.columnCount) <> (Me.Columns.Count))
        End Function
        Public Overrides Sub ResetColumns()
            Dim i As Integer = 0
            Do While ((i) < (Me.Columns.Count))
                If ((((Me.Columns(i)) Is (Me.columnShipCountry))) Or (((((Me.Columns(i)) Is (Me.columnShipPostalCode))) Or (((((Me.Columns(i)) Is (Me.columnShipRegion))) Or (((((Me.Columns(i)) Is (Me.columnShipCity))) Or (((((Me.Columns(i)) Is (Me.columnShipAddress))) Or (((((Me.Columns(i)) Is (Me.columnShipName))) Or (((((Me.Columns(i)) Is (Me.columnFreight))) Or (((((Me.Columns(i)) Is (Me.columnShipVia))) Or (((((Me.Columns(i)) Is (Me.columnShippedDate))) Or (((((Me.Columns(i)) Is (Me.columnRequiredDate))) Or (((((Me.Columns(i)) Is (Me.columnOrderDate))) Or (((((Me.Columns(i)) Is (Me.columnEmployeeID))) Or (((((Me.Columns(i)) Is (Me.columnCustomerID))) Or (((Me.Columns(i)) Is (Me.columnOrderID)))))))))))))))))))))))))))) Then
                Else
                    Me.Columns.Remove(Me.Columns(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        Public Overrides Function ShouldPersistConstraints() As Boolean
            return ((Me.constraintCount) <> (Me.Constraints.Count))
        End Function
        Public Overrides Sub ResetConstraints()
            Dim i As Integer = 0
            Do While ((i) < (Me.Constraints.Count))
                If ((((Me.Constraints(i)) Is (Me.constraintCustomersOrders))) Or (((Me.Constraints(i)) Is (Me.constraintConstraint1)))) Then
                Else
                    Me.Constraints.Remove(Me.Constraints(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        
    End Class
    Public Class Orders_OrderID
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("OrderID", GetType(System.Int32))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AutoIncrement = true
            Me.AllowNull = false
            Me.Unique = true
        End Sub
        
    End Class
    Public Class Orders_CustomerID
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("CustomerID", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_EmployeeID
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("EmployeeID", GetType(System.Int32))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_OrderDate
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("OrderDate", GetType(System.DateTime))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_RequiredDate
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("RequiredDate", GetType(System.DateTime))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShippedDate
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShippedDate", GetType(System.DateTime))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShipVia
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShipVia", GetType(System.Int32))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_Freight
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Freight", GetType(System.Currency))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShipName
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShipName", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShipAddress
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShipAddress", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShipCity
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShipCity", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShipRegion
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShipRegion", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShipPostalCode
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShipPostalCode", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class Orders_ShipCountry
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ShipCountry", GetType(System.String))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
        End Sub
        
    End Class
    Public Class OrderDetails
        Inherits DataTable
        Implements System.Collections.ICollection
        
        Private columnCount As Integer
        Private constraintCount As Integer
        Private columnOrderID As OrderDetails_OrderID
        Private columnProductID As OrderDetails_ProductID
        Private columnUnitPrice As OrderDetails_UnitPrice
        Private columnQuantity As OrderDetails_Quantity
        Private columnDiscount As OrderDetails_Discount
        Private constraintConstraint1 As Constraint
        Private indexByOrderIDProductID As DataColumn()
        Private constraintOrdersOrderDetails As Constraint
        Private OrderDetailsRowChanged As OrderDetailsRowChangeEventHandler
        Private OrderDetailsRowChanging As OrderDetailsRowChangeEventHandler
        Private OrderIDColumnChanging As DataColumnChangeEventHandler
        Private ProductIDColumnChanging As DataColumnChangeEventHandler
        Private UnitPriceColumnChanging As DataColumnChangeEventHandler
        Private QuantityColumnChanging As DataColumnChangeEventHandler
        Private DiscountColumnChanging As DataColumnChangeEventHandler
        
        Overloads Public Sub New(ByVal name As [string])
            MyBase.New(name)
            Me.InitClass
        End Sub
        Overloads Public Sub New()
            MyBase.New("OrderDetails")
            Me.InitClass
        End Sub
        
        Public ReadOnly Property Count As Integer Implements System.Collections.ICollection.Count
            Get
                return Me.Rows.Count
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_IsReadOnly As Boolean Implements System.Collections.ICollection.IsReadOnly
            Get
                return false
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_IsSynchronized As Boolean Implements System.Collections.ICollection.IsSynchronized
            Get
                return false
            End Get
        End Property
        Public ReadOnly Property System_Collections_ICollection_SyncRoot As [object] Implements System.Collections.ICollection.SyncRoot
            Get
                return Me
            End Get
        End Property
        Public ReadOnly Property OrderIDColumn As OrderDetails_OrderID
            Get
                return Me.columnOrderID
            End Get
        End Property
        Public ReadOnly Property ProductIDColumn As OrderDetails_ProductID
            Get
                return Me.columnProductID
            End Get
        End Property
        Public ReadOnly Property UnitPriceColumn As OrderDetails_UnitPrice
            Get
                return Me.columnUnitPrice
            End Get
        End Property
        Public ReadOnly Property QuantityColumn As OrderDetails_Quantity
            Get
                return Me.columnQuantity
            End Get
        End Property
        Public ReadOnly Property DiscountColumn As OrderDetails_Discount
            Get
                return Me.columnDiscount
            End Get
        End Property
        Public ReadOnly Property Item(ByVal index As Integer) As OrderDetailsRow
            Get
                return CType(Me.Rows(index),OrderDetailsRow)
            End Get
        End Property
        
        Public Overloads Sub AddOrderDetailsRow(ByVal rowOrderDetailsRow As OrderDetailsRow)
            Me.Rows.Add(rowOrderDetailsRow)
        End Sub
        Public Overloads Function AddOrderDetailsRow(ByVal parentOrdersRowByOrdersOrderDetails As OrdersRow, ByVal columnProductID As Integer, ByVal columnUnitPrice As System.Currency, ByVal columnQuantity As Short, ByVal columnDiscount As System.Single) As OrderDetailsRow
            Dim rowOrderDetailsRow As OrderDetailsRow
            rowOrderDetailsRow = CType(Me.NewRow,OrderDetailsRow)
            rowOrderDetailsRow.ItemArray = New [Object]() {parentOrdersRowByOrdersOrderDetails.OrderID, columnProductID, columnUnitPrice, columnQuantity, columnDiscount}
            Me.Rows.Add(rowOrderDetailsRow)
            return rowOrderDetailsRow
        End Function
        Public Sub AddOnOrderDetailsRowChanged(ByVal handler As OrderDetailsRowChangeEventHandler)
            Me.OrderDetailsRowChanged = CType(System.Delegate.Combine(Me.OrderDetailsRowChanged, handler),OrderDetailsRowChangeEventHandler)
        End Sub
        Public Sub AddOnOrderDetailsRowChanging(ByVal handler As OrderDetailsRowChangeEventHandler)
            Me.OrderDetailsRowChanging = CType(System.Delegate.Combine(Me.OrderDetailsRowChanging, handler),OrderDetailsRowChangeEventHandler)
        End Sub
        Public Sub RemoveOnOrderDetailsRowChanged(ByVal handler As OrderDetailsRowChangeEventHandler)
            Me.OrderDetailsRowChanged = CType(System.Delegate.Remove(Me.OrderDetailsRowChanged, handler),OrderDetailsRowChangeEventHandler)
        End Sub
        Public Sub RemoveOnOrderDetailsRowChanging(ByVal handler As OrderDetailsRowChangeEventHandler)
            Me.OrderDetailsRowChanging = CType(System.Delegate.Remove(Me.OrderDetailsRowChanging, handler),OrderDetailsRowChangeEventHandler)
        End Sub
        Public Sub AddOnOrderIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.OrderIDColumnChanging = CType(System.Delegate.Combine(Me.OrderIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnOrderIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.OrderIDColumnChanging = CType(System.Delegate.Remove(Me.OrderIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnProductIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ProductIDColumnChanging = CType(System.Delegate.Combine(Me.ProductIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnProductIDColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.ProductIDColumnChanging = CType(System.Delegate.Remove(Me.ProductIDColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnUnitPriceColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.UnitPriceColumnChanging = CType(System.Delegate.Combine(Me.UnitPriceColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnUnitPriceColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.UnitPriceColumnChanging = CType(System.Delegate.Remove(Me.UnitPriceColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnQuantityColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.QuantityColumnChanging = CType(System.Delegate.Combine(Me.QuantityColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnQuantityColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.QuantityColumnChanging = CType(System.Delegate.Remove(Me.QuantityColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub AddOnDiscountColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.DiscountColumnChanging = CType(System.Delegate.Combine(Me.DiscountColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub RemoveOnDiscountColumnChanging(ByVal handler As DataColumnChangeEventHandler)
            Me.DiscountColumnChanging = CType(System.Delegate.Remove(Me.DiscountColumnChanging, handler),DataColumnChangeEventHandler)
        End Sub
        Public Sub System_Collections_ICollection_CopyTo(ByVal array As Array, ByVal offset As Integer) Implements System.Collections.ICollection.CopyTo
            Dim i As Integer = 0
            Do While ((i) < (Me.Rows.Count))
                array.SetValue(Me.Rows(i), ((i) + (offset)))
                i = ((i) + (1))
            Loop
        End Sub
        Public Function FindByOrderIDProductID(ByVal columnOrderID As Integer, ByVal columnProductID As Integer) As OrderDetailsRow
            return CType(Me.Rows.Find(New [Object]() {columnOrderID, columnProductID}),OrderDetailsRow)
        End Function
        Public Function System_Collections_ICollection_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.ICollection.GetEnumerator
            return Me.Rows.All.GetEnumerator
        End Function
        Protected Overrides Function HasSchemaChanged() As Boolean
            return ((Me.columnCount) Is (Me.Columns.Count))
        End Function
        Private Sub InitClass()
            Me.columnCount = 5
            Me.constraintCount = 2
            Me.columnOrderID = New OrderDetails_OrderID
            Me.Columns.Add(Me.columnOrderID)
            Me.columnProductID = New OrderDetails_ProductID
            Me.Columns.Add(Me.columnProductID)
            Me.columnUnitPrice = New OrderDetails_UnitPrice
            Me.Columns.Add(Me.columnUnitPrice)
            Me.columnQuantity = New OrderDetails_Quantity
            Me.Columns.Add(Me.columnQuantity)
            Me.columnDiscount = New OrderDetails_Discount
            Me.Columns.Add(Me.columnDiscount)
            Me.PrimaryKey = System.Data.DataTable.CreateColumnArray(Me.columnOrderID, Me.columnProductID)
            Me.indexByOrderIDProductID = System.Data.DataTable.CreateColumnArray(Me.columnOrderID, Me.columnProductID)
        End Sub
        Public Function NewOrderDetailsRow() As OrderDetailsRow
            return CType(Me.NewRow,OrderDetailsRow)
        End Function
        Protected Overrides Function NewRowFromBuilder(ByVal builder As DataRowBuilder) As DataRow
            'We need to ensure that all Rows in the tabled are typed rows.
            'Table calls newRow whenever it needs to create a row.
            'So the following conditions are covered by Row newRow(Record record)
            '* Cursor calls table.addRecord(record) 
            '* table.addRow(object[] values) calls newRow(record)    
            return New OrderDetailsRow(builder)
        End Function
        Protected Overrides Sub OnRemoveColumn(ByVal column As DataColumn)
            If ((((((((((column) Is (Me.columnOrderID))) Or (((column) Is (Me.columnProductID))))) Or (((column) Is (Me.columnUnitPrice))))) Or (((column) Is (Me.columnQuantity))))) Or (((column) Is (Me.columnDiscount)))) Then
                Throw New ArgumentException("Can't remove column since it it built in to this dataSet")
            End If
        End Sub
        Protected Overrides Sub OnRowChanged(ByVal e As DataRowChangeEventArgs)
            MyBase.OnRowChanged(e)
            If (Not (Me.OrderDetailsRowChanged) Is (Nothing)) Then
                Me.OrderDetailsRowChanged.Invoke(Me, New OrderDetailsRowChangeEvent(CType(e.Row,OrderDetailsRow), e.Action))
            End If
        End Sub
        Protected Overrides Sub OnRowChanging(ByVal e As DataRowChangeEventArgs)
            If (Not (Me.OrderDetailsRowChanging) Is Nothing) Then
                Me.OrderDetailsRowChanging.Invoke(Me, New OrderDetailsRowChangeEvent(CType(e.Row,OrderDetailsRow), e.Action))
            End If
        End Sub
        Protected Sub OnOrderIDColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.OrderIDColumnChanging) Is Nothing) Then
                Me.OrderIDColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnProductIDColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.ProductIDColumnChanging) Is Nothing) Then
                Me.ProductIDColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnUnitPriceColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.UnitPriceColumnChanging) Is Nothing) Then
                Me.UnitPriceColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnQuantityColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.QuantityColumnChanging) Is Nothing) Then
                Me.QuantityColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Sub OnDiscountColumnChanging(ByVal e As DataColumnChangeEventArgs)
            If (Not (Me.DiscountColumnChanging) Is Nothing) Then
                Me.DiscountColumnChanging.Invoke(Me, e)
            End If
        End Sub
        Protected Overrides Sub OnColumnChanging(ByVal e As DataColumnChangeEventArgs)
            MyBase.OnColumnChanging(e)
            If ((e.Column) Is (Me.columnOrderID)) Then
                Me.OnOrderIDColumnChanging(e)
            Else
                If ((e.Column) Is (Me.columnProductID)) Then
                    Me.OnProductIDColumnChanging(e)
                Else
                    If ((e.Column) Is (Me.columnUnitPrice)) Then
                        Me.OnUnitPriceColumnChanging(e)
                    Else
                        If ((e.Column) Is (Me.columnQuantity)) Then
                            Me.OnQuantityColumnChanging(e)
                        Else
                            If ((e.Column) Is (Me.columnDiscount)) Then
                                Me.OnDiscountColumnChanging(e)
                            End If
                        End If
                    End If
                End If
            End If
        End Sub
        Public Sub RemoveOrderDetailsRow(ByVal rowOrderDetailsRow As OrderDetailsRow)
            Me.Rows.Remove(rowOrderDetailsRow)
        End Sub
        Public Overrides Function ShouldPersistPrimaryKey() As Boolean
            return false
        End Function
        Public Overrides Sub ResetPrimaryKey()
        End Sub
        Public Overrides Function ShouldPersistColumns() As Boolean
            return ((Me.columnCount) <> (Me.Columns.Count))
        End Function
        Public Overrides Sub ResetColumns()
            Dim i As Integer = 0
            Do While ((i) < (Me.Columns.Count))
                If ((((Me.Columns(i)) Is (Me.columnDiscount))) Or (((((Me.Columns(i)) Is (Me.columnQuantity))) Or (((((Me.Columns(i)) Is (Me.columnUnitPrice))) Or (((((Me.Columns(i)) Is (Me.columnProductID))) Or (((Me.Columns(i)) Is (Me.columnOrderID)))))))))) Then
                Else
                    Me.Columns.Remove(Me.Columns(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        Public Overrides Function ShouldPersistConstraints() As Boolean
            return ((Me.constraintCount) <> (Me.Constraints.Count))
        End Function
        Public Overrides Sub ResetConstraints()
            Dim i As Integer = 0
            Do While ((i) < (Me.Constraints.Count))
                If ((((Me.Constraints(i)) Is (Me.constraintOrdersOrderDetails))) Or (((Me.Constraints(i)) Is (Me.constraintConstraint1)))) Then
                Else
                    Me.Constraints.Remove(Me.Constraints(i))
                End If
                i = ((i) + (1))
            Loop
        End Sub
        
    End Class
    Public Class OrderDetails_OrderID
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("OrderID", GetType(System.Int32))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AllowNull = false
        End Sub
        
    End Class
    Public Class OrderDetails_ProductID
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("ProductID", GetType(System.Int32))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AllowNull = false
        End Sub
        
    End Class
    Public Class OrderDetails_UnitPrice
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("UnitPrice", GetType(System.Currency))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AllowNull = false
        End Sub
        
    End Class
    Public Class OrderDetails_Quantity
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Quantity", GetType(System.Int16))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AllowNull = false
        End Sub
        
    End Class
    Public Class OrderDetails_Discount
        Inherits System.Data.DataColumn
        
        Public Sub New()
            MyBase.New("Discount", GetType(System.Single))
            Me.InitClass
        End Sub
        
        Public Sub InitClass()
            Me.AllowNull = false
        End Sub
        
    End Class
    Public Class CustomersRow
        Inherits DataRow
        
        Private tableCustomers As Customers
        
        Public Sub New(ByVal rb As DataRowBuilder)
            MyBase.New(rb)
            Me.tableCustomers = CType(Me.Table,Customers)
        End Sub
        
        Public Property CustomerID As String
            Get
                return CType(Me(Me.tableCustomers.CustomerIDColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.CustomerIDColumn) = value
            End Set
        End Property
        Public Property CompanyName As String
            Get
                return CType(Me(Me.tableCustomers.CompanyNameColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.CompanyNameColumn) = value
            End Set
        End Property
        Public Property ContactName As String
            Get
                return CType(Me(Me.tableCustomers.ContactNameColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.ContactNameColumn) = value
            End Set
        End Property
        Public Property ContactNameIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.ContactNameColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.ContactNameColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ContactTitle As String
            Get
                return CType(Me(Me.tableCustomers.ContactTitleColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.ContactTitleColumn) = value
            End Set
        End Property
        Public Property ContactTitleIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.ContactTitleColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.ContactTitleColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property Address As String
            Get
                return CType(Me(Me.tableCustomers.AddressColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.AddressColumn) = value
            End Set
        End Property
        Public Property AddressIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.AddressColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.AddressColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property City As String
            Get
                return CType(Me(Me.tableCustomers.CityColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.CityColumn) = value
            End Set
        End Property
        Public Property CityIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.CityColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.CityColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property Region As String
            Get
                return CType(Me(Me.tableCustomers.RegionColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.RegionColumn) = value
            End Set
        End Property
        Public Property RegionIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.RegionColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.RegionColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property PostalCode As String
            Get
                return CType(Me(Me.tableCustomers.PostalCodeColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.PostalCodeColumn) = value
            End Set
        End Property
        Public Property PostalCodeIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.PostalCodeColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.PostalCodeColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property Country As String
            Get
                return CType(Me(Me.tableCustomers.CountryColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.CountryColumn) = value
            End Set
        End Property
        Public Property CountryIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.CountryColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.CountryColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property Phone As String
            Get
                return CType(Me(Me.tableCustomers.PhoneColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.PhoneColumn) = value
            End Set
        End Property
        Public Property PhoneIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.PhoneColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.PhoneColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property Fax As String
            Get
                return CType(Me(Me.tableCustomers.FaxColumn),String)
            End Get
            Set
                Me(Me.tableCustomers.FaxColumn) = value
            End Set
        End Property
        Public Property FaxIsNull As Boolean
            Get
                return Me.IsNull(Me.tableCustomers.FaxColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableCustomers.FaxColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public ReadOnly Property OrdersByCustomersOrders As OrdersRow()
            Get
                return CType(Me.GetChildRows(Me.Table.ChildRelations("CustomersOrders")),OrdersRow())
            End Get
        End Property
        
    End Class
    Public Class OrdersRow
        Inherits DataRow
        
        Private tableOrders As Orders
        
        Public Sub New(ByVal rb As DataRowBuilder)
            MyBase.New(rb)
            Me.tableOrders = CType(Me.Table,Orders)
        End Sub
        
        Public Property OrderID As Integer
            Get
                return CType(Me(Me.tableOrders.OrderIDColumn),Integer)
            End Get
            Set
                Me(Me.tableOrders.OrderIDColumn) = value
            End Set
        End Property
        Public Property CustomerID As String
            Get
                return CType(Me(Me.tableOrders.CustomerIDColumn),String)
            End Get
            Set
                Me(Me.tableOrders.CustomerIDColumn) = value
            End Set
        End Property
        Public Property CustomerIDIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.CustomerIDColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.CustomerIDColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property EmployeeID As Integer
            Get
                return CType(Me(Me.tableOrders.EmployeeIDColumn),Integer)
            End Get
            Set
                Me(Me.tableOrders.EmployeeIDColumn) = value
            End Set
        End Property
        Public Property EmployeeIDIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.EmployeeIDColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.EmployeeIDColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property OrderDate As DateTime
            Get
                return CType(Me(Me.tableOrders.OrderDateColumn),DateTime)
            End Get
            Set
                Me(Me.tableOrders.OrderDateColumn) = value
            End Set
        End Property
        Public Property OrderDateIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.OrderDateColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.OrderDateColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property RequiredDate As DateTime
            Get
                return CType(Me(Me.tableOrders.RequiredDateColumn),DateTime)
            End Get
            Set
                Me(Me.tableOrders.RequiredDateColumn) = value
            End Set
        End Property
        Public Property RequiredDateIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.RequiredDateColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.RequiredDateColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShippedDate As DateTime
            Get
                return CType(Me(Me.tableOrders.ShippedDateColumn),DateTime)
            End Get
            Set
                Me(Me.tableOrders.ShippedDateColumn) = value
            End Set
        End Property
        Public Property ShippedDateIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShippedDateColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShippedDateColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShipVia As Integer
            Get
                return CType(Me(Me.tableOrders.ShipViaColumn),Integer)
            End Get
            Set
                Me(Me.tableOrders.ShipViaColumn) = value
            End Set
        End Property
        Public Property ShipViaIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShipViaColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShipViaColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property Freight As System.Currency
            Get
                return CType(Me(Me.tableOrders.FreightColumn),System.Currency)
            End Get
            Set
                Me(Me.tableOrders.FreightColumn) = value
            End Set
        End Property
        Public Property FreightIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.FreightColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.FreightColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShipName As String
            Get
                return CType(Me(Me.tableOrders.ShipNameColumn),String)
            End Get
            Set
                Me(Me.tableOrders.ShipNameColumn) = value
            End Set
        End Property
        Public Property ShipNameIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShipNameColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShipNameColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShipAddress As String
            Get
                return CType(Me(Me.tableOrders.ShipAddressColumn),String)
            End Get
            Set
                Me(Me.tableOrders.ShipAddressColumn) = value
            End Set
        End Property
        Public Property ShipAddressIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShipAddressColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShipAddressColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShipCity As String
            Get
                return CType(Me(Me.tableOrders.ShipCityColumn),String)
            End Get
            Set
                Me(Me.tableOrders.ShipCityColumn) = value
            End Set
        End Property
        Public Property ShipCityIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShipCityColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShipCityColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShipRegion As String
            Get
                return CType(Me(Me.tableOrders.ShipRegionColumn),String)
            End Get
            Set
                Me(Me.tableOrders.ShipRegionColumn) = value
            End Set
        End Property
        Public Property ShipRegionIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShipRegionColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShipRegionColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShipPostalCode As String
            Get
                return CType(Me(Me.tableOrders.ShipPostalCodeColumn),String)
            End Get
            Set
                Me(Me.tableOrders.ShipPostalCodeColumn) = value
            End Set
        End Property
        Public Property ShipPostalCodeIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShipPostalCodeColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShipPostalCodeColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public Property ShipCountry As String
            Get
                return CType(Me(Me.tableOrders.ShipCountryColumn),String)
            End Get
            Set
                Me(Me.tableOrders.ShipCountryColumn) = value
            End Set
        End Property
        Public Property ShipCountryIsNull As Boolean
            Get
                return Me.IsNull(Me.tableOrders.ShipCountryColumn)
            End Get
            Set
                If ((value) Is (true)) Then
                    Me(Me.tableOrders.ShipCountryColumn) = [Convert].DBNull
                Else
                    Throw New ArgumentException("Can only set this property to true")
                End If
            End Set
        End Property
        Public ReadOnly Property OrderDetailsByOrdersOrderDetails As OrderDetailsRow()
            Get
                return CType(Me.GetChildRows(Me.Table.ChildRelations("OrdersOrderDetails")),OrderDetailsRow())
            End Get
        End Property
        Public Property CustomersRowByCustomersOrders As CustomersRow
            Get
                return CType(Me.GetParentRow(Me.Table.ParentRelations("CustomersOrders")),CustomersRow)
            End Get
            Set
                Me.Table.ParentRelations("CustomersOrders").SetParentRow(Me, value)
            End Set
        End Property
        
    End Class
    Public Class OrderDetailsRow
        Inherits DataRow
        
        Private tableOrderDetails As OrderDetails
        
        Public Sub New(ByVal rb As DataRowBuilder)
            MyBase.New(rb)
            Me.tableOrderDetails = CType(Me.Table,OrderDetails)
        End Sub
        
        Public Property OrderID As Integer
            Get
                return CType(Me(Me.tableOrderDetails.OrderIDColumn),Integer)
            End Get
            Set
                Me(Me.tableOrderDetails.OrderIDColumn) = value
            End Set
        End Property
        Public Property ProductID As Integer
            Get
                return CType(Me(Me.tableOrderDetails.ProductIDColumn),Integer)
            End Get
            Set
                Me(Me.tableOrderDetails.ProductIDColumn) = value
            End Set
        End Property
        Public Property UnitPrice As System.Currency
            Get
                return CType(Me(Me.tableOrderDetails.UnitPriceColumn),System.Currency)
            End Get
            Set
                Me(Me.tableOrderDetails.UnitPriceColumn) = value
            End Set
        End Property
        Public Property Quantity As Short
            Get
                return CType(Me(Me.tableOrderDetails.QuantityColumn),Short)
            End Get
            Set
                Me(Me.tableOrderDetails.QuantityColumn) = value
            End Set
        End Property
        Public Property Discount As System.Single
            Get
                return CType(Me(Me.tableOrderDetails.DiscountColumn),System.Single)
            End Get
            Set
                Me(Me.tableOrderDetails.DiscountColumn) = value
            End Set
        End Property
        Public Property OrdersRowByOrdersOrderDetails As OrdersRow
            Get
                return CType(Me.GetParentRow(Me.Table.ParentRelations("OrdersOrderDetails")),OrdersRow)
            End Get
            Set
                Me.Table.ParentRelations("OrdersOrderDetails").SetParentRow(Me, value)
            End Set
        End Property
        
    End Class
    Public Class CustomersRowChangeEvent
        Inherits EventArgs
        
        Private rowCustomersRow As CustomersRow
        Private actionValue As System.Data.DataRowAction
        
        Public Sub New(ByVal rowCustomersRowArg As CustomersRow, ByVal actionArg As DataRowAction)
            MyBase.New
            Me.rowCustomersRow = rowCustomersRowArg
            Me.actionValue = actionArg
        End Sub
        
        Public ReadOnly Property CustomersRow As CustomersRow
            Get
                return Me.rowCustomersRow
            End Get
        End Property
        Public ReadOnly Property Action As DataRowAction
            Get
                return Me.actionValue
            End Get
        End Property
        
    End Class
    Public Class OrdersRowChangeEvent
        Inherits EventArgs
        
        Private rowOrdersRow As OrdersRow
        Private actionValue As System.Data.DataRowAction
        
        Public Sub New(ByVal rowOrdersRowArg As OrdersRow, ByVal actionArg As DataRowAction)
            MyBase.New
            Me.rowOrdersRow = rowOrdersRowArg
            Me.actionValue = actionArg
        End Sub
        
        Public ReadOnly Property OrdersRow As OrdersRow
            Get
                return Me.rowOrdersRow
            End Get
        End Property
        Public ReadOnly Property Action As DataRowAction
            Get
                return Me.actionValue
            End Get
        End Property
        
    End Class
    Public Class OrderDetailsRowChangeEvent
        Inherits EventArgs
        
        Private rowOrderDetailsRow As OrderDetailsRow
        Private actionValue As System.Data.DataRowAction
        
        Public Sub New(ByVal rowOrderDetailsRowArg As OrderDetailsRow, ByVal actionArg As DataRowAction)
            MyBase.New
            Me.rowOrderDetailsRow = rowOrderDetailsRowArg
            Me.actionValue = actionArg
        End Sub
        
        Public ReadOnly Property OrderDetailsRow As OrderDetailsRow
            Get
                return Me.rowOrderDetailsRow
            End Get
        End Property
        Public ReadOnly Property Action As DataRowAction
            Get
                return Me.actionValue
            End Get
        End Property
        
    End Class
    Public Delegate Sub CustomersRowChangeEventHandler(ByVal sender As [object], ByVal e As CustomersRowChangeEvent)
    Public Delegate Sub OrdersRowChangeEventHandler(ByVal sender As [object], ByVal e As OrdersRowChangeEvent)
    Public Delegate Sub OrderDetailsRowChangeEventHandler(ByVal sender As [object], ByVal e As OrderDetailsRowChangeEvent)
End Namespace
