'------------------------------------------------------------------------------
'/ <copyright from='1997' to='2001' company='Microsoft Corporation'>           
'/    Copyright (c) Microsoft Corporation. All Rights Reserved.                
'/       
'/    This source code is intended only as a supplement to Microsoft
'/    Development Tools and/or on-line documentation.  See these other
'/    materials for detailed information regarding Microsoft code samples.
'/
'/ </copyright>                                                                
'------------------------------------------------------------------------------
Imports System
Imports System.ComponentModel
Imports System.Drawing
Imports System.WinForms

Namespace Microsoft.Samples.WinForms.VB.HelloWorldForm 

    Public Class HelloWorldForm
        Inherits System.WinForms.Form

        'Required by the Win Forms Designer   
        Private components As System.ComponentModel.Container
        Private button1 As New System.WinForms.Button
        Private textBox1 As New System.WinForms.TextBox

        'When the application is started show the Form
        Shared Sub Main()
            System.WinForms.Application.Run(New HelloWorldForm())
        End Sub
    
        Public Sub New()
           
            MyBase.New
    
            'Set up the Form
            Me.Text = "Hello WinForms World"
            Me.AutoScaleBaseSize = new Size(5, 13)
            Me.ClientSize = new Size(392, 117)

            'Set the minimum form size to the client size + the height of the title bar
            Me.MinTrackSize = new Size(392, (117 + SystemInformation.CaptionHeight))

            'Set the default button on the Form
            Me.AcceptButton=button1	

            'Create the button
            button1.Location = new Point(256, 64)
            button1.Size = new Size(120, 40)
            button1.TabIndex = 2
            button1.Text = "Click Me!"

            'Register the event handler
            button1.AddOnClick(AddressOf buttonClicked)

            'Create the text box
            textBox1.Text = "Hello WinForms World"
            textBox1.TabIndex = 1
            textBox1.Size = new Size(360, 20)
            textBox1.Location = new Point(16, 24)
            
            'Add the controls to the form
            Me.Controls.Add(button1)
            Me.Controls.Add(textBox1)

        End Sub

        'Called when the Form closes
        'Note that the MessageBox call is simply to
        'demonstrate that Dispose is called. You 
        'should keep your Dispose method code as simple and 
        'robust as possible
        Overrides Public Sub Dispose()
            MyBase.Dispose()
            Try 		
                MessageBox.Show("Disposed!")
            Catch ex As Exception
            End Try
            
        End Sub

        'The event handling method
        Private Sub buttonClicked(sender As Object, evArgs As EventArgs) 
            MessageBox.Show("Text is: '" + textBox1.Text + "'")
        End Sub
        
    End Class
    
End Namespace









